diff --git a/libselinux/man/man8/selinux.8 b/libselinux/man/man8/selinux.8
index 5842150b..9c466d57 100644
--- a/libselinux/man/man8/selinux.8
+++ b/libselinux/man/man8/selinux.8
@@ -1,9 +1,9 @@
 .TH  "selinux"  "8"  "29 Apr 2005" "dwalsh@redhat.com" "SELinux Command Line documentation"
 .SH "NAME"
-SELinux \- NSA Security-Enhanced Linux (SELinux)
+SELinux \- Security-Enhanced Linux (SELinux)
 .
 .SH "DESCRIPTION"
-NSA Security-Enhanced Linux (SELinux) is an implementation of a
+Security-Enhanced Linux (SELinux) is an implementation of a
 flexible mandatory access control architecture in the Linux operating
 system.  The SELinux architecture provides general support for the
 enforcement of many kinds of mandatory access control policies,
diff --git a/libselinux/man/ru/man8/selinux.8 b/libselinux/man/ru/man8/selinux.8
index 271809de..4ab64276 100644
--- a/libselinux/man/ru/man8/selinux.8
+++ b/libselinux/man/ru/man8/selinux.8
@@ -1,9 +1,9 @@
 .TH  "selinux"  "8"  "29 апреля 2005" "dwalsh@redhat.com" "Документация по командной строке SELinux"
 .SH "ИМЯ"
-SELinux \- Linux с улучшенной безопасностью от NSA (SELinux)
+SELinux \- Linux с улучшенной безопасностью от (SELinux)
 .
 .SH "ОПИСАНИЕ"
-Linux с улучшенной безопасностью от NSA - это реализация гибкой архитектуры мандатного
+Linux с улучшенной безопасностью от - это реализация гибкой архитектуры мандатного
 управления доступом в операционной системе Linux. Архитектура SELinux предоставляет
 общую поддержку использования различных видов политик мандатного управления доступом,
 включая основанные на концепциях Type Enforcement® (принудительное присвоение типов),
diff --git a/policycoreutils/load_policy/load_policy.8 b/policycoreutils/load_policy/load_policy.8
index 0810995c..867c35e4 100644
--- a/policycoreutils/load_policy/load_policy.8
+++ b/policycoreutils/load_policy/load_policy.8
@@ -1,4 +1,4 @@
-.TH LOAD_POLICY "8" "May 2003" "Security Enhanced Linux" NSA
+.TH LOAD_POLICY "8" "May 2003" "Security Enhanced Linux"
 .SH NAME
 load_policy \- load a new SELinux policy into the kernel
 
diff --git a/policycoreutils/load_policy/ru/load_policy.8 b/policycoreutils/load_policy/ru/load_policy.8
index db3d9f65..25140b2e 100644
--- a/policycoreutils/load_policy/ru/load_policy.8
+++ b/policycoreutils/load_policy/ru/load_policy.8
@@ -1,4 +1,4 @@
-.TH LOAD_POLICY "8" "Май 2003" "Security Enhanced Linux" NSA
+.TH LOAD_POLICY "8" "Май 2003" "Security Enhanced Linux"
 .SH ИМЯ
 load_policy \- загрузить новую политику SELinux в ядро
 
diff --git a/policycoreutils/newrole/newrole.1 b/policycoreutils/newrole/newrole.1
index 893c42f7..544274d7 100644
--- a/policycoreutils/newrole/newrole.1
+++ b/policycoreutils/newrole/newrole.1
@@ -1,4 +1,4 @@
-.TH NEWROLE "1" "October 2000" "Security Enhanced Linux" NSA
+.TH NEWROLE "1" "October 2000" "Security Enhanced Linux"
 .SH NAME
 newrole \- run a shell with a new SELinux role
 .SH SYNOPSIS
diff --git a/policycoreutils/newrole/ru/newrole.1 b/policycoreutils/newrole/ru/newrole.1
index c4078789..6d9c6dd0 100644
--- a/policycoreutils/newrole/ru/newrole.1
+++ b/policycoreutils/newrole/ru/newrole.1
@@ -1,4 +1,4 @@
-.TH NEWROLE "1" "Октябрь 2000" "Security Enhanced Linux" NSA
+.TH NEWROLE "1" "Октябрь 2000" "Security Enhanced Linux"
 .SH ИМЯ
 newrole \- запустить оболочку с новой ролью SELinux
 .SH ОБЗОР
diff --git a/policycoreutils/run_init/open_init_pty.8 b/policycoreutils/run_init/open_init_pty.8
index 4b0a2f3c..8bfb9d69 100644
--- a/policycoreutils/run_init/open_init_pty.8
+++ b/policycoreutils/run_init/open_init_pty.8
@@ -22,7 +22,7 @@
 .\" USA.
 .\"
 .\"
-.TH OPEN_INIT_PTY "8" "January 2005" "Security Enhanced Linux" NSA
+.TH OPEN_INIT_PTY "8" "January 2005" "Security Enhanced Linux"
 .SH NAME
 open_init_pty \- run an program under a pseudo terminal
 .SH SYNOPSIS
diff --git a/policycoreutils/run_init/ru/open_init_pty.8 b/policycoreutils/run_init/ru/open_init_pty.8
index bac4fd94..143941e1 100644
--- a/policycoreutils/run_init/ru/open_init_pty.8
+++ b/policycoreutils/run_init/ru/open_init_pty.8
@@ -22,7 +22,7 @@
 .\" USA.
 .\"
 .\"
-.TH OPEN_INIT_PTY "8" "Январь 2005" "Security Enhanced Linux" NSA
+.TH OPEN_INIT_PTY "8" "Январь 2005" "Security Enhanced Linux"
 .SH ИМЯ
 open_init_pty \- запустить программу под псевдотерминалом
 .SH ОБЗОР
diff --git a/policycoreutils/run_init/ru/run_init.8 b/policycoreutils/run_init/ru/run_init.8
index 174d9c53..26b767ce 100644
--- a/policycoreutils/run_init/ru/run_init.8
+++ b/policycoreutils/run_init/ru/run_init.8
@@ -1,4 +1,4 @@
-.TH RUN_INIT "8" "Май 2003" "Security Enhanced Linux" NSA
+.TH RUN_INIT "8" "Май 2003" "Security Enhanced Linux"
 .SH ИМЯ
 run_init \- запустить сценарий init в правильном контексте SELinux
 .SH ОБЗОР
diff --git a/policycoreutils/run_init/run_init.8 b/policycoreutils/run_init/run_init.8
index a031d5d2..d7ff45d0 100644
--- a/policycoreutils/run_init/run_init.8
+++ b/policycoreutils/run_init/run_init.8
@@ -1,4 +1,4 @@
-.TH RUN_INIT "8" "May 2003" "Security Enhanced Linux" NSA
+.TH RUN_INIT "8" "May 2003" "Security Enhanced Linux"
 .SH NAME
 run_init \- run an init script in the proper SELinux context
 .SH SYNOPSIS
diff --git a/policycoreutils/secon/ru/secon.1 b/policycoreutils/secon/ru/secon.1
index acbc14fb..3c9aa535 100644
--- a/policycoreutils/secon/ru/secon.1
+++ b/policycoreutils/secon/ru/secon.1
@@ -1,4 +1,4 @@
-.TH SECON "1" "Апрель 2006" "Security Enhanced Linux" NSA
+.TH SECON "1" "Апрель 2006" "Security Enhanced Linux"
 .SH ИМЯ
 secon \- показать контекст SELinux для файла, программы или ввода пользователя.
 .SH ОБЗОР
diff --git a/policycoreutils/secon/secon.1 b/policycoreutils/secon/secon.1
index c0e8b05a..1a454edc 100644
--- a/policycoreutils/secon/secon.1
+++ b/policycoreutils/secon/secon.1
@@ -1,4 +1,4 @@
-.TH SECON "1" "April 2006" "Security Enhanced Linux" NSA
+.TH SECON "1" "April 2006" "Security Enhanced Linux"
 .SH NAME
 secon \- See an SELinux context, from a file, program or user input.
 .SH SYNOPSIS
diff --git a/policycoreutils/semodule/ru/semodule.8 b/policycoreutils/semodule/ru/semodule.8
index 26515201..d7ff9b56 100644
--- a/policycoreutils/semodule/ru/semodule.8
+++ b/policycoreutils/semodule/ru/semodule.8
@@ -1,4 +1,4 @@
-.TH SEMODULE "8" "Ноябрь 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE "8" "Ноябрь 2005" "Security Enhanced Linux"
 .SH ИМЯ 
 semodule \- управление модулями политики SELinux.
 
diff --git a/policycoreutils/semodule/semodule.8 b/policycoreutils/semodule/semodule.8
index 01757b00..00c60c1e 100644
--- a/policycoreutils/semodule/semodule.8
+++ b/policycoreutils/semodule/semodule.8
@@ -1,4 +1,4 @@
-.TH SEMODULE "8" "Nov 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE "8" "Nov 2005" "Security Enhanced Linux"
 .SH NAME
 semodule \- Manage SELinux policy modules.
 
diff --git a/python/audit2allow/audit2allow.1 b/python/audit2allow/audit2allow.1
index c31021d3..c208b3b2 100644
--- a/python/audit2allow/audit2allow.1
+++ b/python/audit2allow/audit2allow.1
@@ -23,7 +23,7 @@
 .\" USA.
 .\"
 .\"
-.TH AUDIT2ALLOW "1" "October 2010" "Security Enhanced Linux" NSA
+.TH AUDIT2ALLOW "1" "October 2010" "Security Enhanced Linux"
 .SH NAME
 .BR audit2allow
 \- generate SELinux policy allow/dontaudit rules from logs of denied operations
diff --git a/python/audit2allow/ru/audit2allow.1 b/python/audit2allow/ru/audit2allow.1
index 1633fa3b..b631895d 100644
--- a/python/audit2allow/ru/audit2allow.1
+++ b/python/audit2allow/ru/audit2allow.1
@@ -23,7 +23,7 @@
 .\" USA.
 .\"
 .\"
-.TH AUDIT2ALLOW "1" "Октябрь 2010" "Security Enhanced Linux" NSA
+.TH AUDIT2ALLOW "1" "Октябрь 2010" "Security Enhanced Linux"
 .SH ИМЯ
 .BR audit2allow
 \- создаёт правила политики SELinux allow/dontaudit из журналов отклонённых операций
diff --git a/semodule-utils/semodule_expand/ru/semodule_expand.8 b/semodule-utils/semodule_expand/ru/semodule_expand.8
index afdc129e..28b381af 100644
--- a/semodule-utils/semodule_expand/ru/semodule_expand.8
+++ b/semodule-utils/semodule_expand/ru/semodule_expand.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_EXPAND "8" "ноябрь 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_EXPAND "8" "ноябрь 2005" "Security Enhanced Linux"
 .SH ИМЯ 
 semodule_expand \- расширить пакет модуля политики SELinux
 
diff --git a/semodule-utils/semodule_expand/semodule_expand.8 b/semodule-utils/semodule_expand/semodule_expand.8
index 1b482a1f..eba7b40e 100644
--- a/semodule-utils/semodule_expand/semodule_expand.8
+++ b/semodule-utils/semodule_expand/semodule_expand.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_EXPAND "8" "Nov 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_EXPAND "8" "Nov 2005" "Security Enhanced Linux"
 .SH NAME 
 semodule_expand \- Expand a SELinux policy module package.
 
diff --git a/semodule-utils/semodule_link/ru/semodule_link.8 b/semodule-utils/semodule_link/ru/semodule_link.8
index 31d81206..4a8f414e 100644
--- a/semodule-utils/semodule_link/ru/semodule_link.8
+++ b/semodule-utils/semodule_link/ru/semodule_link.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_LINK "8" "Ноябрь 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_LINK "8" "Ноябрь 2005" "Security Enhanced Linux"
 .SH ИМЯ 
 semodule_link \- связать вместе пакеты модулей политики SELinux
 
diff --git a/semodule-utils/semodule_link/semodule_link.8 b/semodule-utils/semodule_link/semodule_link.8
index a2bda3f9..95a9ba19 100644
--- a/semodule-utils/semodule_link/semodule_link.8
+++ b/semodule-utils/semodule_link/semodule_link.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_LINK "8" "Nov 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_LINK "8" "Nov 2005" "Security Enhanced Linux"
 .SH NAME 
 semodule_link \- Link SELinux policy module packages together
 
diff --git a/semodule-utils/semodule_package/ru/semodule_package.8 b/semodule-utils/semodule_package/ru/semodule_package.8
index 6af67b29..3f4b16a9 100644
--- a/semodule-utils/semodule_package/ru/semodule_package.8
+++ b/semodule-utils/semodule_package/ru/semodule_package.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_PACKAGE "8" "Ноябрь 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_PACKAGE "8" "Ноябрь 2005" "Security Enhanced Linux"
 .SH ИМЯ 
 semodule_package \- создать пакет модуля политики SELinux
 
diff --git a/semodule-utils/semodule_package/ru/semodule_unpackage.8 b/semodule-utils/semodule_package/ru/semodule_unpackage.8
index 910fee02..6c7e234b 100644
--- a/semodule-utils/semodule_package/ru/semodule_unpackage.8
+++ b/semodule-utils/semodule_package/ru/semodule_unpackage.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_PACKAGE "8" "Ноябрь 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_PACKAGE "8" "Ноябрь 2005" "Security Enhanced Linux"
 .SH ИМЯ
 semodule_unpackage \- извлечь модуль политики и файл контекстов файлов из пакета модуля политики SELinux
 
diff --git a/semodule-utils/semodule_package/semodule_package.8 b/semodule-utils/semodule_package/semodule_package.8
index 9697cc55..1d64bad3 100644
--- a/semodule-utils/semodule_package/semodule_package.8
+++ b/semodule-utils/semodule_package/semodule_package.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_PACKAGE "8" "Nov 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_PACKAGE "8" "Nov 2005" "Security Enhanced Linux"
 .SH NAME 
 semodule_package \- Create a SELinux policy module package.
 
diff --git a/semodule-utils/semodule_package/semodule_unpackage.8 b/semodule-utils/semodule_package/semodule_unpackage.8
index 5c92bf51..0432f7a1 100644
--- a/semodule-utils/semodule_package/semodule_unpackage.8
+++ b/semodule-utils/semodule_package/semodule_unpackage.8
@@ -1,4 +1,4 @@
-.TH SEMODULE_PACKAGE "8" "Nov 2005" "Security Enhanced Linux" NSA
+.TH SEMODULE_PACKAGE "8" "Nov 2005" "Security Enhanced Linux"
 .SH NAME
 semodule_unpackage \- Extract policy module and file context file from an SELinux policy module package.
 